Index: trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 79277)
+++ trunk/src/VBox/Frontends/VirtualBox/src/softkeyboard/UISoftKeyboard.cpp	(revision 79281)
@@ -1355,5 +1355,4 @@
 void UISoftKeyboardKey::updateText()
 {
-
     QPainter painter(&m_textPixmap);
     painter.setPen(QColor(0,0,0));
@@ -1365,5 +1364,5 @@
     painter.setFont(painterFont);
     QFontMetrics fontMetric = painter.fontMetrics();
-    int iSideMargin = 1 * fontMetric.width('X');
+    int iSideMargin = 0.5 * fontMetric.width('X');
 
     int iX = 0;
@@ -2094,4 +2093,6 @@
     m_pShowPositionsAction->setCheckable(true);
     m_pShowPositionsAction->setChecked(false);
+#else
+    Q_UNUSED(m_pShowPositionsAction);
 #endif
 
Index: trunk/src/VBox/Frontends/VirtualBox/xml/german.xml
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/xml/german.xml	(revision 79277)
+++ trunk/src/VBox/Frontends/VirtualBox/xml/german.xml	(revision 79281)
@@ -2,10 +2,11 @@
 <layout>
     <name>German</name>
-    <physicallayoutid>{368efa94-3744-48c5-9d5a-59c2f15fe5ec}</physicallayoutid>
+    <physicallayoutid>{d41a0398-92a0-4ba4-beba-3d91a5dd0e50}</physicallayoutid>
     <key>
         <position>110</position>
-        <basecaption>Escxx</basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>Esc</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -14,4 +15,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -20,4 +22,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -26,4 +29,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -32,4 +36,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -38,4 +43,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -44,4 +50,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -50,4 +57,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -56,4 +64,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -62,4 +71,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -68,4 +78,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -74,4 +85,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -80,4 +92,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -86,4 +99,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -92,4 +106,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -98,10 +113,12 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>1</position>
-        <basecaption>`</basecaption>
-        <shiftcaption>~</shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>^</basecaption>
+        <shiftcaption>°</shiftcaption>
+        <altgrcaption>′</altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -110,22 +127,26 @@
         <shiftcaption>!</shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>3</position>
-        <basecaption>2</basecaption>
-        <shiftcaption>@</shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption></basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>4</position>
-        <basecaption>3</basecaption>
-        <shiftcaption>#</shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption></basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>5</position>
-        <basecaption>4</basecaption>
-        <shiftcaption>$</shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption></basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -134,4 +155,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -140,4 +162,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -146,4 +169,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -152,4 +176,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -158,4 +183,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -164,4 +190,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -170,4 +197,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -176,10 +204,12 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>15</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>Backspace</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -188,4 +218,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -194,4 +225,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -200,4 +232,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -206,82 +239,96 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>17</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>Q</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>18</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>W</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>19</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>E</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>20</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>R</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>21</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>T</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>22</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>Z</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>23</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>U</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>24</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>I</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>25</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>O</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>26</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>P</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>27</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>Ü</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>28</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
-    </key>
-    <key>
-        <position>29</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>+</basecaption>
+        <shiftcaption>*</shiftcaption>
+        <altgrcaption>~</altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
+    </key>
+    <key>
+        <position>43</position>
+        <basecaption></basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -290,4 +337,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -296,4 +344,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -302,4 +351,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -308,76 +358,89 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>31</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>A</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>32</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>S</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>33</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>D</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>34</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>F</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>35</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>G</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>36</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>H</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>37</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>J</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>38</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>K</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>39</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>L</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>40</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>Ö</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>41</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
-    </key>
-    <key>
-        <position>43</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>Ä</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
+    </key>
+    <key>
+        <position>42</position>
+        <basecaption>#</basecaption>
+        <shiftcaption>'</shiftcaption>
+        <altgrcaption>’</altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -386,10 +449,19 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
+    </key>
+    <key>
+        <position>45</position>
+        <basecaption>&lt;</basecaption>
+        <shiftcaption>&gt;</shiftcaption>
+        <altgrcaption>|</altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>46</position>
-        <basecaption>Z</basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>Y</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -398,4 +470,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -404,4 +477,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -410,4 +484,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -416,4 +491,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -422,4 +498,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -428,28 +505,33 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>53</position>
-        <basecaption>,</basecaption>
-        <shiftcaption>&lt;</shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>,I</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>54</position>
         <basecaption>.</basecaption>
-        <shiftcaption>&gt;</shiftcaption>
-        <altgrcaption></altgrcaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>55</position>
-        <basecaption>/</basecaption>
-        <shiftcaption>?</shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>-</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>57</position>
-        <basecaption></basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption>Shift</basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -458,10 +540,12 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
         <position>58</position>
-        <basecaption>Ctrl</basecaption>
-        <shiftcaption></shiftcaption>
-        <altgrcaption></altgrcaption>
+        <basecaption></basecaption>
+        <shiftcaption></shiftcaption>
+        <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -470,4 +554,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -476,4 +561,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -482,4 +568,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -488,4 +575,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -494,4 +582,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -500,4 +589,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -506,4 +596,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -512,4 +603,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -518,4 +610,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
     <key>
@@ -524,4 +617,5 @@
         <shiftcaption></shiftcaption>
         <altgrcaption></altgrcaption>
+        <shiftaltgrcaption></shiftaltgrcaption>
     </key>
 </layout>